unit MDIChild;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ObjEdit, ExtCtrls, ObjInsp, ComCtrls, DB, DBTables;

type
  TForm2 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    Query: TQuery;
    procedure BeforeDelete(Sender: TObjectEditor; AComp: TComponent; var Can: Boolean);
  public
    FEditor: TObjectEditor;
  end;

var
  Form2: TForm2;
  FInspector: TObjectInspector;

implementation

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
  FEditor := TObjectEditor.Create;
  FEditor.BeforeDelete := BeforeDelete;
  FEditor.FInspector := FInspector;
  Query := TQuery.Create(nil);
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  FEditor.Free;
  Query.Free;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  FEditor.EditControl(Self);
end;

procedure TForm2.BeforeDelete(Sender: TObjectEditor; AComp: TComponent; var Can: Boolean);
begin
  Can := AComp.ClassNameIs('TButton');
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  ShowMessage('Event not lost !!');
end;

initialization
begin
  FInspector := TObjectInspector.Create(nil);
end;

finalization
begin
  FInspector.Free;
end;

end.
